# outils.R : some useful routines

# eval_str() : execute a string
eval_str = function(str){
	eval(parse(text=str))
}

# ones(): creates an array (/vector/matrix) with only 1 [and appropriate names / dimnames]
ones = function(x) {
	z=x-x+1
	z[is.na(z)]=1
	return(z)
}

# max.which()
max.which = function(X) return(max(which(X)))

# min.which()
min.which = function(X) return(min(which(X)))

# nnames()
nnames = function(X) return(names(dimnames(X)))

# dropd(): drop requested dimensions of an array
dropd = function(X,drop=c()) {
	# X: input array, with dim and dimnames
	# drop: dimensions to be droped
	if (is.null(dim(X))) stop("Error in dropd: input array has no dimentions")
	d = dim(X)
	# Check that dimensions to be dropped are all 1
	if (!prod(d[drop]==1)) stop("Error in dropd: dimensions to drop are > 1")
	d_new = d[-drop]
	if (!is.null(dimnames(X))) {
		dn = dimnames(X)
		dn_new = dn[-drop]
	}
	return(array(X,dim=d_new,dimnames=dn_new))
}

# matrix_sqrt()
matrix_sqrt = function(M){
	Md = eigen(M)
	return(Re(Md$vectors) %*% diag(sqrt(pmax(Re(Md$values),0))) %*% t(Re(Md$vectors)))
}
